// Code generated - DO NOT EDIT.
// This file is a generated binding and any manual changes will be lost.

package contributor

import (
	"errors"
	"math/big"
	"strings"

	ethereum "github.com/ethereum/go-ethereum"
	"github.com/ethereum/go-ethereum/accounts/abi"
	"github.com/ethereum/go-ethereum/accounts/abi/bind"
	"github.com/ethereum/go-ethereum/common"
	"github.com/ethereum/go-ethereum/core/types"
	"github.com/ethereum/go-ethereum/event"
)

// Reference imports to suppress errors if they are not otherwise used.
var (
	_ = errors.New
	_ = big.NewInt
	_ = strings.NewReader
	_ = ethereum.NotFound
	_ = bind.Bind
	_ = common.Big1
	_ = types.BloomLookup
	_ = event.NewSubscription
)

// ContributorMetaData contains all meta data concerning the Contributor contract.
var ContributorMetaData = &bind.MetaData{
	ABI: "[{\"anonymous\":false,\"inputs\":[{\"indexed\":false,\"internalType\":\"uint32\",\"name\":\"id\",\"type\":\"uint32\"},{\"indexed\":false,\"internalType\":\"address\",\"name\":\"oldAccount\",\"type\":\"address\"},{\"indexed\":false,\"internalType\":\"address\",\"name\":\"newAccount\",\"type\":\"address\"}],\"name\":\"ContributorAccountUpdated\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":false,\"internalType\":\"uint32\",\"name\":\"id\",\"type\":\"uint32\"},{\"indexed\":false,\"internalType\":\"address\",\"name\":\"account\",\"type\":\"address\"}],\"name\":\"ContributorAdded\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":false,\"internalType\":\"uint32\",\"name\":\"id\",\"type\":\"uint32\"},{\"indexed\":false,\"internalType\":\"bytes32\",\"name\":\"oldHashDigest\",\"type\":\"bytes32\"},{\"indexed\":false,\"internalType\":\"bytes32\",\"name\":\"newHashDigest\",\"type\":\"bytes32\"}],\"name\":\"ContributorProfileUpdated\",\"type\":\"event\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"account\",\"type\":\"address\"},{\"internalType\":\"bytes32\",\"name\":\"hashDigest\",\"type\":\"bytes32\"},{\"internalType\":\"uint8\",\"name\":\"hashFunction\",\"type\":\"uint8\"},{\"internalType\":\"uint8\",\"name\":\"hashSize\",\"type\":\"uint8\"}],\"name\":\"addContributor\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"account\",\"type\":\"address\"}],\"name\":\"addressExists\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"account\",\"type\":\"address\"}],\"name\":\"addressIsCore\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"contributionContract\",\"outputs\":[{\"internalType\":\"contractIContributionBalance\",\"name\":\"\",\"type\":\"address\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"\",\"type\":\"address\"}],\"name\":\"contributorIds\",\"outputs\":[{\"internalType\":\"uint32\",\"name\":\"\",\"type\":\"uint32\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint32\",\"name\":\"\",\"type\":\"uint32\"}],\"name\":\"contributors\",\"outputs\":[{\"internalType\":\"address\",\"name\":\"account\",\"type\":\"address\"},{\"internalType\":\"bytes32\",\"name\":\"hashDigest\",\"type\":\"bytes32\"},{\"internalType\":\"uint8\",\"name\":\"hashFunction\",\"type\":\"uint8\"},{\"internalType\":\"uint8\",\"name\":\"hashSize\",\"type\":\"uint8\"},{\"internalType\":\"bool\",\"name\":\"exists\",\"type\":\"bool\"},{\"internalType\":\"uint32\",\"name\":\"kreditsWithdrawn\",\"type\":\"uint32\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"contributorsCount\",\"outputs\":[{\"internalType\":\"uint32\",\"name\":\"\",\"type\":\"uint32\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"coreContributorsCount\",\"outputs\":[{\"internalType\":\"uint32\",\"name\":\"\",\"type\":\"uint32\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"deployer\",\"outputs\":[{\"internalType\":\"address\",\"name\":\"\",\"type\":\"address\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint32\",\"name\":\"id\",\"type\":\"uint32\"}],\"name\":\"exists\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint32\",\"name\":\"id\",\"type\":\"uint32\"}],\"name\":\"getContributorAddressById\",\"outputs\":[{\"internalType\":\"address\",\"name\":\"\",\"type\":\"address\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint32\",\"name\":\"_id\",\"type\":\"uint32\"}],\"name\":\"getContributorById\",\"outputs\":[{\"internalType\":\"uint32\",\"name\":\"id\",\"type\":\"uint32\"},{\"internalType\":\"address\",\"name\":\"account\",\"type\":\"address\"},{\"internalType\":\"bytes32\",\"name\":\"hashDigest\",\"type\":\"bytes32\"},{\"internalType\":\"uint8\",\"name\":\"hashFunction\",\"type\":\"uint8\"},{\"internalType\":\"uint8\",\"name\":\"hashSize\",\"type\":\"uint8\"},{\"internalType\":\"bool\",\"name\":\"isCore\",\"type\":\"bool\"},{\"internalType\":\"uint256\",\"name\":\"balance\",\"type\":\"uint256\"},{\"internalType\":\"uint32\",\"name\":\"totalKreditsEarned\",\"type\":\"uint32\"},{\"internalType\":\"uint256\",\"name\":\"contributionsCount\",\"type\":\"uint256\"},{\"internalType\":\"bool\",\"name\":\"exists\",\"type\":\"bool\"},{\"internalType\":\"uint256\",\"name\":\"kreditsWithdrawn\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"account\",\"type\":\"address\"}],\"name\":\"getContributorIdByAddress\",\"outputs\":[{\"internalType\":\"uint32\",\"name\":\"\",\"type\":\"uint32\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"initialize\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint32\",\"name\":\"id\",\"type\":\"uint32\"}],\"name\":\"isCoreTeam\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"contribution\",\"type\":\"address\"}],\"name\":\"setContributionContract\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"token\",\"type\":\"address\"}],\"name\":\"setTokenContract\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"tokenContract\",\"outputs\":[{\"internalType\":\"contractIToken\",\"name\":\"\",\"type\":\"address\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint32\",\"name\":\"id\",\"type\":\"uint32\"},{\"internalType\":\"address\",\"name\":\"oldAccount\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"newAccount\",\"type\":\"address\"}],\"name\":\"updateContributorAccount\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint32\",\"name\":\"id\",\"type\":\"uint32\"},{\"internalType\":\"bytes32\",\"name\":\"hashDigest\",\"type\":\"bytes32\"},{\"internalType\":\"uint8\",\"name\":\"hashFunction\",\"type\":\"uint8\"},{\"internalType\":\"uint8\",\"name\":\"hashSize\",\"type\":\"uint8\"}],\"name\":\"updateContributorProfileHash\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"withdraw\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"}]",
}

// ContributorABI is the input ABI used to generate the binding from.
// Deprecated: Use ContributorMetaData.ABI instead.
var ContributorABI = ContributorMetaData.ABI

// Contributor is an auto generated Go binding around an Ethereum contract.
type Contributor struct {
	ContributorCaller     // Read-only binding to the contract
	ContributorTransactor // Write-only binding to the contract
	ContributorFilterer   // Log filterer for contract events
}

// ContributorCaller is an auto generated read-only Go binding around an Ethereum contract.
type ContributorCaller struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// ContributorTransactor is an auto generated write-only Go binding around an Ethereum contract.
type ContributorTransactor struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// ContributorFilterer is an auto generated log filtering Go binding around an Ethereum contract events.
type ContributorFilterer struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// ContributorSession is an auto generated Go binding around an Ethereum contract,
// with pre-set call and transact options.
type ContributorSession struct {
	Contract     *Contributor      // Generic contract binding to set the session for
	CallOpts     bind.CallOpts     // Call options to use throughout this session
	TransactOpts bind.TransactOpts // Transaction auth options to use throughout this session
}

// ContributorCallerSession is an auto generated read-only Go binding around an Ethereum contract,
// with pre-set call options.
type ContributorCallerSession struct {
	Contract *ContributorCaller // Generic contract caller binding to set the session for
	CallOpts bind.CallOpts      // Call options to use throughout this session
}

// ContributorTransactorSession is an auto generated write-only Go binding around an Ethereum contract,
// with pre-set transact options.
type ContributorTransactorSession struct {
	Contract     *ContributorTransactor // Generic contract transactor binding to set the session for
	TransactOpts bind.TransactOpts      // Transaction auth options to use throughout this session
}

// ContributorRaw is an auto generated low-level Go binding around an Ethereum contract.
type ContributorRaw struct {
	Contract *Contributor // Generic contract binding to access the raw methods on
}

// ContributorCallerRaw is an auto generated low-level read-only Go binding around an Ethereum contract.
type ContributorCallerRaw struct {
	Contract *ContributorCaller // Generic read-only contract binding to access the raw methods on
}

// ContributorTransactorRaw is an auto generated low-level write-only Go binding around an Ethereum contract.
type ContributorTransactorRaw struct {
	Contract *ContributorTransactor // Generic write-only contract binding to access the raw methods on
}

// NewContributor creates a new instance of Contributor, bound to a specific deployed contract.
func NewContributor(address common.Address, backend bind.ContractBackend) (*Contributor, error) {
	contract, err := bindContributor(address, backend, backend, backend)
	if err != nil {
		return nil, err
	}
	return &Contributor{ContributorCaller: ContributorCaller{contract: contract}, ContributorTransactor: ContributorTransactor{contract: contract}, ContributorFilterer: ContributorFilterer{contract: contract}}, nil
}

// NewContributorCaller creates a new read-only instance of Contributor, bound to a specific deployed contract.
func NewContributorCaller(address common.Address, caller bind.ContractCaller) (*ContributorCaller, error) {
	contract, err := bindContributor(address, caller, nil, nil)
	if err != nil {
		return nil, err
	}
	return &ContributorCaller{contract: contract}, nil
}

// NewContributorTransactor creates a new write-only instance of Contributor, bound to a specific deployed contract.
func NewContributorTransactor(address common.Address, transactor bind.ContractTransactor) (*ContributorTransactor, error) {
	contract, err := bindContributor(address, nil, transactor, nil)
	if err != nil {
		return nil, err
	}
	return &ContributorTransactor{contract: contract}, nil
}

// NewContributorFilterer creates a new log filterer instance of Contributor, bound to a specific deployed contract.
func NewContributorFilterer(address common.Address, filterer bind.ContractFilterer) (*ContributorFilterer, error) {
	contract, err := bindContributor(address, nil, nil, filterer)
	if err != nil {
		return nil, err
	}
	return &ContributorFilterer{contract: contract}, nil
}

// bindContributor binds a generic wrapper to an already deployed contract.
func bindContributor(address common.Address, caller bind.ContractCaller, transactor bind.ContractTransactor, filterer bind.ContractFilterer) (*bind.BoundContract, error) {
	parsed, err := abi.JSON(strings.NewReader(ContributorABI))
	if err != nil {
		return nil, err
	}
	return bind.NewBoundContract(address, parsed, caller, transactor, filterer), nil
}

// Call invokes the (constant) contract method with params as input values and
// sets the output to result. The result type might be a single field for simple
// returns, a slice of interfaces for anonymous returns and a struct for named
// returns.
func (_Contributor *ContributorRaw) Call(opts *bind.CallOpts, result *[]interface{}, method string, params ...interface{}) error {
	return _Contributor.Contract.ContributorCaller.contract.Call(opts, result, method, params...)
}

// Transfer initiates a plain transaction to move funds to the contract, calling
// its default method if one is available.
func (_Contributor *ContributorRaw) Transfer(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _Contributor.Contract.ContributorTransactor.contract.Transfer(opts)
}

// Transact invokes the (paid) contract method with params as input values.
func (_Contributor *ContributorRaw) Transact(opts *bind.TransactOpts, method string, params ...interface{}) (*types.Transaction, error) {
	return _Contributor.Contract.ContributorTransactor.contract.Transact(opts, method, params...)
}

// Call invokes the (constant) contract method with params as input values and
// sets the output to result. The result type might be a single field for simple
// returns, a slice of interfaces for anonymous returns and a struct for named
// returns.
func (_Contributor *ContributorCallerRaw) Call(opts *bind.CallOpts, result *[]interface{}, method string, params ...interface{}) error {
	return _Contributor.Contract.contract.Call(opts, result, method, params...)
}

// Transfer initiates a plain transaction to move funds to the contract, calling
// its default method if one is available.
func (_Contributor *ContributorTransactorRaw) Transfer(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _Contributor.Contract.contract.Transfer(opts)
}

// Transact invokes the (paid) contract method with params as input values.
func (_Contributor *ContributorTransactorRaw) Transact(opts *bind.TransactOpts, method string, params ...interface{}) (*types.Transaction, error) {
	return _Contributor.Contract.contract.Transact(opts, method, params...)
}

// AddressExists is a free data retrieval call binding the contract method 0xa5025222.
//
// Solidity: function addressExists(address account) view returns(bool)
func (_Contributor *ContributorCaller) AddressExists(opts *bind.CallOpts, account common.Address) (bool, error) {
	var out []interface{}
	err := _Contributor.contract.Call(opts, &out, "addressExists", account)

	if err != nil {
		return *new(bool), err
	}

	out0 := *abi.ConvertType(out[0], new(bool)).(*bool)

	return out0, err

}

// AddressExists is a free data retrieval call binding the contract method 0xa5025222.
//
// Solidity: function addressExists(address account) view returns(bool)
func (_Contributor *ContributorSession) AddressExists(account common.Address) (bool, error) {
	return _Contributor.Contract.AddressExists(&_Contributor.CallOpts, account)
}

// AddressExists is a free data retrieval call binding the contract method 0xa5025222.
//
// Solidity: function addressExists(address account) view returns(bool)
func (_Contributor *ContributorCallerSession) AddressExists(account common.Address) (bool, error) {
	return _Contributor.Contract.AddressExists(&_Contributor.CallOpts, account)
}

// AddressIsCore is a free data retrieval call binding the contract method 0x5c2707de.
//
// Solidity: function addressIsCore(address account) view returns(bool)
func (_Contributor *ContributorCaller) AddressIsCore(opts *bind.CallOpts, account common.Address) (bool, error) {
	var out []interface{}
	err := _Contributor.contract.Call(opts, &out, "addressIsCore", account)

	if err != nil {
		return *new(bool), err
	}

	out0 := *abi.ConvertType(out[0], new(bool)).(*bool)

	return out0, err

}

// AddressIsCore is a free data retrieval call binding the contract method 0x5c2707de.
//
// Solidity: function addressIsCore(address account) view returns(bool)
func (_Contributor *ContributorSession) AddressIsCore(account common.Address) (bool, error) {
	return _Contributor.Contract.AddressIsCore(&_Contributor.CallOpts, account)
}

// AddressIsCore is a free data retrieval call binding the contract method 0x5c2707de.
//
// Solidity: function addressIsCore(address account) view returns(bool)
func (_Contributor *ContributorCallerSession) AddressIsCore(account common.Address) (bool, error) {
	return _Contributor.Contract.AddressIsCore(&_Contributor.CallOpts, account)
}

// ContributionContract is a free data retrieval call binding the contract method 0xddfdec60.
//
// Solidity: function contributionContract() view returns(address)
func (_Contributor *ContributorCaller) ContributionContract(opts *bind.CallOpts) (common.Address, error) {
	var out []interface{}
	err := _Contributor.contract.Call(opts, &out, "contributionContract")

	if err != nil {
		return *new(common.Address), err
	}

	out0 := *abi.ConvertType(out[0], new(common.Address)).(*common.Address)

	return out0, err

}

// ContributionContract is a free data retrieval call binding the contract method 0xddfdec60.
//
// Solidity: function contributionContract() view returns(address)
func (_Contributor *ContributorSession) ContributionContract() (common.Address, error) {
	return _Contributor.Contract.ContributionContract(&_Contributor.CallOpts)
}

// ContributionContract is a free data retrieval call binding the contract method 0xddfdec60.
//
// Solidity: function contributionContract() view returns(address)
func (_Contributor *ContributorCallerSession) ContributionContract() (common.Address, error) {
	return _Contributor.Contract.ContributionContract(&_Contributor.CallOpts)
}

// ContributorIds is a free data retrieval call binding the contract method 0x8bfbe466.
//
// Solidity: function contributorIds(address ) view returns(uint32)
func (_Contributor *ContributorCaller) ContributorIds(opts *bind.CallOpts, arg0 common.Address) (uint32, error) {
	var out []interface{}
	err := _Contributor.contract.Call(opts, &out, "contributorIds", arg0)

	if err != nil {
		return *new(uint32), err
	}

	out0 := *abi.ConvertType(out[0], new(uint32)).(*uint32)

	return out0, err

}

// ContributorIds is a free data retrieval call binding the contract method 0x8bfbe466.
//
// Solidity: function contributorIds(address ) view returns(uint32)
func (_Contributor *ContributorSession) ContributorIds(arg0 common.Address) (uint32, error) {
	return _Contributor.Contract.ContributorIds(&_Contributor.CallOpts, arg0)
}

// ContributorIds is a free data retrieval call binding the contract method 0x8bfbe466.
//
// Solidity: function contributorIds(address ) view returns(uint32)
func (_Contributor *ContributorCallerSession) ContributorIds(arg0 common.Address) (uint32, error) {
	return _Contributor.Contract.ContributorIds(&_Contributor.CallOpts, arg0)
}

// Contributors is a free data retrieval call binding the contract method 0xa04f68b2.
//
// Solidity: function contributors(uint32 ) view returns(address account, bytes32 hashDigest, uint8 hashFunction, uint8 hashSize, bool exists, uint32 kreditsWithdrawn)
func (_Contributor *ContributorCaller) Contributors(opts *bind.CallOpts, arg0 uint32) (struct {
	Account          common.Address
	HashDigest       [32]byte
	HashFunction     uint8
	HashSize         uint8
	Exists           bool
	KreditsWithdrawn uint32
}, error) {
	var out []interface{}
	err := _Contributor.contract.Call(opts, &out, "contributors", arg0)

	outstruct := new(struct {
		Account          common.Address
		HashDigest       [32]byte
		HashFunction     uint8
		HashSize         uint8
		Exists           bool
		KreditsWithdrawn uint32
	})
	if err != nil {
		return *outstruct, err
	}

	outstruct.Account = *abi.ConvertType(out[0], new(common.Address)).(*common.Address)
	outstruct.HashDigest = *abi.ConvertType(out[1], new([32]byte)).(*[32]byte)
	outstruct.HashFunction = *abi.ConvertType(out[2], new(uint8)).(*uint8)
	outstruct.HashSize = *abi.ConvertType(out[3], new(uint8)).(*uint8)
	outstruct.Exists = *abi.ConvertType(out[4], new(bool)).(*bool)
	outstruct.KreditsWithdrawn = *abi.ConvertType(out[5], new(uint32)).(*uint32)

	return *outstruct, err

}

// Contributors is a free data retrieval call binding the contract method 0xa04f68b2.
//
// Solidity: function contributors(uint32 ) view returns(address account, bytes32 hashDigest, uint8 hashFunction, uint8 hashSize, bool exists, uint32 kreditsWithdrawn)
func (_Contributor *ContributorSession) Contributors(arg0 uint32) (struct {
	Account          common.Address
	HashDigest       [32]byte
	HashFunction     uint8
	HashSize         uint8
	Exists           bool
	KreditsWithdrawn uint32
}, error) {
	return _Contributor.Contract.Contributors(&_Contributor.CallOpts, arg0)
}

// Contributors is a free data retrieval call binding the contract method 0xa04f68b2.
//
// Solidity: function contributors(uint32 ) view returns(address account, bytes32 hashDigest, uint8 hashFunction, uint8 hashSize, bool exists, uint32 kreditsWithdrawn)
func (_Contributor *ContributorCallerSession) Contributors(arg0 uint32) (struct {
	Account          common.Address
	HashDigest       [32]byte
	HashFunction     uint8
	HashSize         uint8
	Exists           bool
	KreditsWithdrawn uint32
}, error) {
	return _Contributor.Contract.Contributors(&_Contributor.CallOpts, arg0)
}

// ContributorsCount is a free data retrieval call binding the contract method 0x7569b3d7.
//
// Solidity: function contributorsCount() view returns(uint32)
func (_Contributor *ContributorCaller) ContributorsCount(opts *bind.CallOpts) (uint32, error) {
	var out []interface{}
	err := _Contributor.contract.Call(opts, &out, "contributorsCount")

	if err != nil {
		return *new(uint32), err
	}

	out0 := *abi.ConvertType(out[0], new(uint32)).(*uint32)

	return out0, err

}

// ContributorsCount is a free data retrieval call binding the contract method 0x7569b3d7.
//
// Solidity: function contributorsCount() view returns(uint32)
func (_Contributor *ContributorSession) ContributorsCount() (uint32, error) {
	return _Contributor.Contract.ContributorsCount(&_Contributor.CallOpts)
}

// ContributorsCount is a free data retrieval call binding the contract method 0x7569b3d7.
//
// Solidity: function contributorsCount() view returns(uint32)
func (_Contributor *ContributorCallerSession) ContributorsCount() (uint32, error) {
	return _Contributor.Contract.ContributorsCount(&_Contributor.CallOpts)
}

// CoreContributorsCount is a free data retrieval call binding the contract method 0x44fb4596.
//
// Solidity: function coreContributorsCount() view returns(uint32)
func (_Contributor *ContributorCaller) CoreContributorsCount(opts *bind.CallOpts) (uint32, error) {
	var out []interface{}
	err := _Contributor.contract.Call(opts, &out, "coreContributorsCount")

	if err != nil {
		return *new(uint32), err
	}

	out0 := *abi.ConvertType(out[0], new(uint32)).(*uint32)

	return out0, err

}

// CoreContributorsCount is a free data retrieval call binding the contract method 0x44fb4596.
//
// Solidity: function coreContributorsCount() view returns(uint32)
func (_Contributor *ContributorSession) CoreContributorsCount() (uint32, error) {
	return _Contributor.Contract.CoreContributorsCount(&_Contributor.CallOpts)
}

// CoreContributorsCount is a free data retrieval call binding the contract method 0x44fb4596.
//
// Solidity: function coreContributorsCount() view returns(uint32)
func (_Contributor *ContributorCallerSession) CoreContributorsCount() (uint32, error) {
	return _Contributor.Contract.CoreContributorsCount(&_Contributor.CallOpts)
}

// Deployer is a free data retrieval call binding the contract method 0xd5f39488.
//
// Solidity: function deployer() view returns(address)
func (_Contributor *ContributorCaller) Deployer(opts *bind.CallOpts) (common.Address, error) {
	var out []interface{}
	err := _Contributor.contract.Call(opts, &out, "deployer")

	if err != nil {
		return *new(common.Address), err
	}

	out0 := *abi.ConvertType(out[0], new(common.Address)).(*common.Address)

	return out0, err

}

// Deployer is a free data retrieval call binding the contract method 0xd5f39488.
//
// Solidity: function deployer() view returns(address)
func (_Contributor *ContributorSession) Deployer() (common.Address, error) {
	return _Contributor.Contract.Deployer(&_Contributor.CallOpts)
}

// Deployer is a free data retrieval call binding the contract method 0xd5f39488.
//
// Solidity: function deployer() view returns(address)
func (_Contributor *ContributorCallerSession) Deployer() (common.Address, error) {
	return _Contributor.Contract.Deployer(&_Contributor.CallOpts)
}

// Exists is a free data retrieval call binding the contract method 0x13c369ed.
//
// Solidity: function exists(uint32 id) view returns(bool)
func (_Contributor *ContributorCaller) Exists(opts *bind.CallOpts, id uint32) (bool, error) {
	var out []interface{}
	err := _Contributor.contract.Call(opts, &out, "exists", id)

	if err != nil {
		return *new(bool), err
	}

	out0 := *abi.ConvertType(out[0], new(bool)).(*bool)

	return out0, err

}

// Exists is a free data retrieval call binding the contract method 0x13c369ed.
//
// Solidity: function exists(uint32 id) view returns(bool)
func (_Contributor *ContributorSession) Exists(id uint32) (bool, error) {
	return _Contributor.Contract.Exists(&_Contributor.CallOpts, id)
}

// Exists is a free data retrieval call binding the contract method 0x13c369ed.
//
// Solidity: function exists(uint32 id) view returns(bool)
func (_Contributor *ContributorCallerSession) Exists(id uint32) (bool, error) {
	return _Contributor.Contract.Exists(&_Contributor.CallOpts, id)
}

// GetContributorAddressById is a free data retrieval call binding the contract method 0x27266309.
//
// Solidity: function getContributorAddressById(uint32 id) view returns(address)
func (_Contributor *ContributorCaller) GetContributorAddressById(opts *bind.CallOpts, id uint32) (common.Address, error) {
	var out []interface{}
	err := _Contributor.contract.Call(opts, &out, "getContributorAddressById", id)

	if err != nil {
		return *new(common.Address), err
	}

	out0 := *abi.ConvertType(out[0], new(common.Address)).(*common.Address)

	return out0, err

}

// GetContributorAddressById is a free data retrieval call binding the contract method 0x27266309.
//
// Solidity: function getContributorAddressById(uint32 id) view returns(address)
func (_Contributor *ContributorSession) GetContributorAddressById(id uint32) (common.Address, error) {
	return _Contributor.Contract.GetContributorAddressById(&_Contributor.CallOpts, id)
}

// GetContributorAddressById is a free data retrieval call binding the contract method 0x27266309.
//
// Solidity: function getContributorAddressById(uint32 id) view returns(address)
func (_Contributor *ContributorCallerSession) GetContributorAddressById(id uint32) (common.Address, error) {
	return _Contributor.Contract.GetContributorAddressById(&_Contributor.CallOpts, id)
}

// GetContributorById is a free data retrieval call binding the contract method 0x7234fd67.
//
// Solidity: function getContributorById(uint32 _id) view returns(uint32 id, address account, bytes32 hashDigest, uint8 hashFunction, uint8 hashSize, bool isCore, uint256 balance, uint32 totalKreditsEarned, uint256 contributionsCount, bool exists, uint256 kreditsWithdrawn)
func (_Contributor *ContributorCaller) GetContributorById(opts *bind.CallOpts, _id uint32) (struct {
	Id                 uint32
	Account            common.Address
	HashDigest         [32]byte
	HashFunction       uint8
	HashSize           uint8
	IsCore             bool
	Balance            *big.Int
	TotalKreditsEarned uint32
	ContributionsCount *big.Int
	Exists             bool
	KreditsWithdrawn   *big.Int
}, error) {
	var out []interface{}
	err := _Contributor.contract.Call(opts, &out, "getContributorById", _id)

	outstruct := new(struct {
		Id                 uint32
		Account            common.Address
		HashDigest         [32]byte
		HashFunction       uint8
		HashSize           uint8
		IsCore             bool
		Balance            *big.Int
		TotalKreditsEarned uint32
		ContributionsCount *big.Int
		Exists             bool
		KreditsWithdrawn   *big.Int
	})
	if err != nil {
		return *outstruct, err
	}

	outstruct.Id = *abi.ConvertType(out[0], new(uint32)).(*uint32)
	outstruct.Account = *abi.ConvertType(out[1], new(common.Address)).(*common.Address)
	outstruct.HashDigest = *abi.ConvertType(out[2], new([32]byte)).(*[32]byte)
	outstruct.HashFunction = *abi.ConvertType(out[3], new(uint8)).(*uint8)
	outstruct.HashSize = *abi.ConvertType(out[4], new(uint8)).(*uint8)
	outstruct.IsCore = *abi.ConvertType(out[5], new(bool)).(*bool)
	outstruct.Balance = *abi.ConvertType(out[6], new(*big.Int)).(**big.Int)
	outstruct.TotalKreditsEarned = *abi.ConvertType(out[7], new(uint32)).(*uint32)
	outstruct.ContributionsCount = *abi.ConvertType(out[8], new(*big.Int)).(**big.Int)
	outstruct.Exists = *abi.ConvertType(out[9], new(bool)).(*bool)
	outstruct.KreditsWithdrawn = *abi.ConvertType(out[10], new(*big.Int)).(**big.Int)

	return *outstruct, err

}

// GetContributorById is a free data retrieval call binding the contract method 0x7234fd67.
//
// Solidity: function getContributorById(uint32 _id) view returns(uint32 id, address account, bytes32 hashDigest, uint8 hashFunction, uint8 hashSize, bool isCore, uint256 balance, uint32 totalKreditsEarned, uint256 contributionsCount, bool exists, uint256 kreditsWithdrawn)
func (_Contributor *ContributorSession) GetContributorById(_id uint32) (struct {
	Id                 uint32
	Account            common.Address
	HashDigest         [32]byte
	HashFunction       uint8
	HashSize           uint8
	IsCore             bool
	Balance            *big.Int
	TotalKreditsEarned uint32
	ContributionsCount *big.Int
	Exists             bool
	KreditsWithdrawn   *big.Int
}, error) {
	return _Contributor.Contract.GetContributorById(&_Contributor.CallOpts, _id)
}

// GetContributorById is a free data retrieval call binding the contract method 0x7234fd67.
//
// Solidity: function getContributorById(uint32 _id) view returns(uint32 id, address account, bytes32 hashDigest, uint8 hashFunction, uint8 hashSize, bool isCore, uint256 balance, uint32 totalKreditsEarned, uint256 contributionsCount, bool exists, uint256 kreditsWithdrawn)
func (_Contributor *ContributorCallerSession) GetContributorById(_id uint32) (struct {
	Id                 uint32
	Account            common.Address
	HashDigest         [32]byte
	HashFunction       uint8
	HashSize           uint8
	IsCore             bool
	Balance            *big.Int
	TotalKreditsEarned uint32
	ContributionsCount *big.Int
	Exists             bool
	KreditsWithdrawn   *big.Int
}, error) {
	return _Contributor.Contract.GetContributorById(&_Contributor.CallOpts, _id)
}

// GetContributorIdByAddress is a free data retrieval call binding the contract method 0x28dcb8f2.
//
// Solidity: function getContributorIdByAddress(address account) view returns(uint32)
func (_Contributor *ContributorCaller) GetContributorIdByAddress(opts *bind.CallOpts, account common.Address) (uint32, error) {
	var out []interface{}
	err := _Contributor.contract.Call(opts, &out, "getContributorIdByAddress", account)

	if err != nil {
		return *new(uint32), err
	}

	out0 := *abi.ConvertType(out[0], new(uint32)).(*uint32)

	return out0, err

}

// GetContributorIdByAddress is a free data retrieval call binding the contract method 0x28dcb8f2.
//
// Solidity: function getContributorIdByAddress(address account) view returns(uint32)
func (_Contributor *ContributorSession) GetContributorIdByAddress(account common.Address) (uint32, error) {
	return _Contributor.Contract.GetContributorIdByAddress(&_Contributor.CallOpts, account)
}

// GetContributorIdByAddress is a free data retrieval call binding the contract method 0x28dcb8f2.
//
// Solidity: function getContributorIdByAddress(address account) view returns(uint32)
func (_Contributor *ContributorCallerSession) GetContributorIdByAddress(account common.Address) (uint32, error) {
	return _Contributor.Contract.GetContributorIdByAddress(&_Contributor.CallOpts, account)
}

// IsCoreTeam is a free data retrieval call binding the contract method 0xf192ebea.
//
// Solidity: function isCoreTeam(uint32 id) view returns(bool)
func (_Contributor *ContributorCaller) IsCoreTeam(opts *bind.CallOpts, id uint32) (bool, error) {
	var out []interface{}
	err := _Contributor.contract.Call(opts, &out, "isCoreTeam", id)

	if err != nil {
		return *new(bool), err
	}

	out0 := *abi.ConvertType(out[0], new(bool)).(*bool)

	return out0, err

}

// IsCoreTeam is a free data retrieval call binding the contract method 0xf192ebea.
//
// Solidity: function isCoreTeam(uint32 id) view returns(bool)
func (_Contributor *ContributorSession) IsCoreTeam(id uint32) (bool, error) {
	return _Contributor.Contract.IsCoreTeam(&_Contributor.CallOpts, id)
}

// IsCoreTeam is a free data retrieval call binding the contract method 0xf192ebea.
//
// Solidity: function isCoreTeam(uint32 id) view returns(bool)
func (_Contributor *ContributorCallerSession) IsCoreTeam(id uint32) (bool, error) {
	return _Contributor.Contract.IsCoreTeam(&_Contributor.CallOpts, id)
}

// TokenContract is a free data retrieval call binding the contract method 0x55a373d6.
//
// Solidity: function tokenContract() view returns(address)
func (_Contributor *ContributorCaller) TokenContract(opts *bind.CallOpts) (common.Address, error) {
	var out []interface{}
	err := _Contributor.contract.Call(opts, &out, "tokenContract")

	if err != nil {
		return *new(common.Address), err
	}

	out0 := *abi.ConvertType(out[0], new(common.Address)).(*common.Address)

	return out0, err

}

// TokenContract is a free data retrieval call binding the contract method 0x55a373d6.
//
// Solidity: function tokenContract() view returns(address)
func (_Contributor *ContributorSession) TokenContract() (common.Address, error) {
	return _Contributor.Contract.TokenContract(&_Contributor.CallOpts)
}

// TokenContract is a free data retrieval call binding the contract method 0x55a373d6.
//
// Solidity: function tokenContract() view returns(address)
func (_Contributor *ContributorCallerSession) TokenContract() (common.Address, error) {
	return _Contributor.Contract.TokenContract(&_Contributor.CallOpts)
}

// AddContributor is a paid mutator transaction binding the contract method 0x16572ba7.
//
// Solidity: function addContributor(address account, bytes32 hashDigest, uint8 hashFunction, uint8 hashSize) returns()
func (_Contributor *ContributorTransactor) AddContributor(opts *bind.TransactOpts, account common.Address, hashDigest [32]byte, hashFunction uint8, hashSize uint8) (*types.Transaction, error) {
	return _Contributor.contract.Transact(opts, "addContributor", account, hashDigest, hashFunction, hashSize)
}

// AddContributor is a paid mutator transaction binding the contract method 0x16572ba7.
//
// Solidity: function addContributor(address account, bytes32 hashDigest, uint8 hashFunction, uint8 hashSize) returns()
func (_Contributor *ContributorSession) AddContributor(account common.Address, hashDigest [32]byte, hashFunction uint8, hashSize uint8) (*types.Transaction, error) {
	return _Contributor.Contract.AddContributor(&_Contributor.TransactOpts, account, hashDigest, hashFunction, hashSize)
}

// AddContributor is a paid mutator transaction binding the contract method 0x16572ba7.
//
// Solidity: function addContributor(address account, bytes32 hashDigest, uint8 hashFunction, uint8 hashSize) returns()
func (_Contributor *ContributorTransactorSession) AddContributor(account common.Address, hashDigest [32]byte, hashFunction uint8, hashSize uint8) (*types.Transaction, error) {
	return _Contributor.Contract.AddContributor(&_Contributor.TransactOpts, account, hashDigest, hashFunction, hashSize)
}

// Initialize is a paid mutator transaction binding the contract method 0x8129fc1c.
//
// Solidity: function initialize() returns()
func (_Contributor *ContributorTransactor) Initialize(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _Contributor.contract.Transact(opts, "initialize")
}

// Initialize is a paid mutator transaction binding the contract method 0x8129fc1c.
//
// Solidity: function initialize() returns()
func (_Contributor *ContributorSession) Initialize() (*types.Transaction, error) {
	return _Contributor.Contract.Initialize(&_Contributor.TransactOpts)
}

// Initialize is a paid mutator transaction binding the contract method 0x8129fc1c.
//
// Solidity: function initialize() returns()
func (_Contributor *ContributorTransactorSession) Initialize() (*types.Transaction, error) {
	return _Contributor.Contract.Initialize(&_Contributor.TransactOpts)
}

// SetContributionContract is a paid mutator transaction binding the contract method 0x85480556.
//
// Solidity: function setContributionContract(address contribution) returns()
func (_Contributor *ContributorTransactor) SetContributionContract(opts *bind.TransactOpts, contribution common.Address) (*types.Transaction, error) {
	return _Contributor.contract.Transact(opts, "setContributionContract", contribution)
}

// SetContributionContract is a paid mutator transaction binding the contract method 0x85480556.
//
// Solidity: function setContributionContract(address contribution) returns()
func (_Contributor *ContributorSession) SetContributionContract(contribution common.Address) (*types.Transaction, error) {
	return _Contributor.Contract.SetContributionContract(&_Contributor.TransactOpts, contribution)
}

// SetContributionContract is a paid mutator transaction binding the contract method 0x85480556.
//
// Solidity: function setContributionContract(address contribution) returns()
func (_Contributor *ContributorTransactorSession) SetContributionContract(contribution common.Address) (*types.Transaction, error) {
	return _Contributor.Contract.SetContributionContract(&_Contributor.TransactOpts, contribution)
}

// SetTokenContract is a paid mutator transaction binding the contract method 0xbbcd5bbe.
//
// Solidity: function setTokenContract(address token) returns()
func (_Contributor *ContributorTransactor) SetTokenContract(opts *bind.TransactOpts, token common.Address) (*types.Transaction, error) {
	return _Contributor.contract.Transact(opts, "setTokenContract", token)
}

// SetTokenContract is a paid mutator transaction binding the contract method 0xbbcd5bbe.
//
// Solidity: function setTokenContract(address token) returns()
func (_Contributor *ContributorSession) SetTokenContract(token common.Address) (*types.Transaction, error) {
	return _Contributor.Contract.SetTokenContract(&_Contributor.TransactOpts, token)
}

// SetTokenContract is a paid mutator transaction binding the contract method 0xbbcd5bbe.
//
// Solidity: function setTokenContract(address token) returns()
func (_Contributor *ContributorTransactorSession) SetTokenContract(token common.Address) (*types.Transaction, error) {
	return _Contributor.Contract.SetTokenContract(&_Contributor.TransactOpts, token)
}

// UpdateContributorAccount is a paid mutator transaction binding the contract method 0x0d2bcbc0.
//
// Solidity: function updateContributorAccount(uint32 id, address oldAccount, address newAccount) returns()
func (_Contributor *ContributorTransactor) UpdateContributorAccount(opts *bind.TransactOpts, id uint32, oldAccount common.Address, newAccount common.Address) (*types.Transaction, error) {
	return _Contributor.contract.Transact(opts, "updateContributorAccount", id, oldAccount, newAccount)
}

// UpdateContributorAccount is a paid mutator transaction binding the contract method 0x0d2bcbc0.
//
// Solidity: function updateContributorAccount(uint32 id, address oldAccount, address newAccount) returns()
func (_Contributor *ContributorSession) UpdateContributorAccount(id uint32, oldAccount common.Address, newAccount common.Address) (*types.Transaction, error) {
	return _Contributor.Contract.UpdateContributorAccount(&_Contributor.TransactOpts, id, oldAccount, newAccount)
}

// UpdateContributorAccount is a paid mutator transaction binding the contract method 0x0d2bcbc0.
//
// Solidity: function updateContributorAccount(uint32 id, address oldAccount, address newAccount) returns()
func (_Contributor *ContributorTransactorSession) UpdateContributorAccount(id uint32, oldAccount common.Address, newAccount common.Address) (*types.Transaction, error) {
	return _Contributor.Contract.UpdateContributorAccount(&_Contributor.TransactOpts, id, oldAccount, newAccount)
}

// UpdateContributorProfileHash is a paid mutator transaction binding the contract method 0xb2b16dc0.
//
// Solidity: function updateContributorProfileHash(uint32 id, bytes32 hashDigest, uint8 hashFunction, uint8 hashSize) returns()
func (_Contributor *ContributorTransactor) UpdateContributorProfileHash(opts *bind.TransactOpts, id uint32, hashDigest [32]byte, hashFunction uint8, hashSize uint8) (*types.Transaction, error) {
	return _Contributor.contract.Transact(opts, "updateContributorProfileHash", id, hashDigest, hashFunction, hashSize)
}

// UpdateContributorProfileHash is a paid mutator transaction binding the contract method 0xb2b16dc0.
//
// Solidity: function updateContributorProfileHash(uint32 id, bytes32 hashDigest, uint8 hashFunction, uint8 hashSize) returns()
func (_Contributor *ContributorSession) UpdateContributorProfileHash(id uint32, hashDigest [32]byte, hashFunction uint8, hashSize uint8) (*types.Transaction, error) {
	return _Contributor.Contract.UpdateContributorProfileHash(&_Contributor.TransactOpts, id, hashDigest, hashFunction, hashSize)
}

// UpdateContributorProfileHash is a paid mutator transaction binding the contract method 0xb2b16dc0.
//
// Solidity: function updateContributorProfileHash(uint32 id, bytes32 hashDigest, uint8 hashFunction, uint8 hashSize) returns()
func (_Contributor *ContributorTransactorSession) UpdateContributorProfileHash(id uint32, hashDigest [32]byte, hashFunction uint8, hashSize uint8) (*types.Transaction, error) {
	return _Contributor.Contract.UpdateContributorProfileHash(&_Contributor.TransactOpts, id, hashDigest, hashFunction, hashSize)
}

// Withdraw is a paid mutator transaction binding the contract method 0x3ccfd60b.
//
// Solidity: function withdraw() returns()
func (_Contributor *ContributorTransactor) Withdraw(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _Contributor.contract.Transact(opts, "withdraw")
}

// Withdraw is a paid mutator transaction binding the contract method 0x3ccfd60b.
//
// Solidity: function withdraw() returns()
func (_Contributor *ContributorSession) Withdraw() (*types.Transaction, error) {
	return _Contributor.Contract.Withdraw(&_Contributor.TransactOpts)
}

// Withdraw is a paid mutator transaction binding the contract method 0x3ccfd60b.
//
// Solidity: function withdraw() returns()
func (_Contributor *ContributorTransactorSession) Withdraw() (*types.Transaction, error) {
	return _Contributor.Contract.Withdraw(&_Contributor.TransactOpts)
}

// ContributorContributorAccountUpdatedIterator is returned from FilterContributorAccountUpdated and is used to iterate over the raw logs and unpacked data for ContributorAccountUpdated events raised by the Contributor contract.
type ContributorContributorAccountUpdatedIterator struct {
	Event *ContributorContributorAccountUpdated // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *ContributorContributorAccountUpdatedIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(ContributorContributorAccountUpdated)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(ContributorContributorAccountUpdated)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *ContributorContributorAccountUpdatedIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *ContributorContributorAccountUpdatedIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// ContributorContributorAccountUpdated represents a ContributorAccountUpdated event raised by the Contributor contract.
type ContributorContributorAccountUpdated struct {
	Id         uint32
	OldAccount common.Address
	NewAccount common.Address
	Raw        types.Log // Blockchain specific contextual infos
}

// FilterContributorAccountUpdated is a free log retrieval operation binding the contract event 0x3ac4f1ef6607b971c009b0cd01c93eac3e87abd9626b0197b553fd4edba5f9c5.
//
// Solidity: event ContributorAccountUpdated(uint32 id, address oldAccount, address newAccount)
func (_Contributor *ContributorFilterer) FilterContributorAccountUpdated(opts *bind.FilterOpts) (*ContributorContributorAccountUpdatedIterator, error) {

	logs, sub, err := _Contributor.contract.FilterLogs(opts, "ContributorAccountUpdated")
	if err != nil {
		return nil, err
	}
	return &ContributorContributorAccountUpdatedIterator{contract: _Contributor.contract, event: "ContributorAccountUpdated", logs: logs, sub: sub}, nil
}

// WatchContributorAccountUpdated is a free log subscription operation binding the contract event 0x3ac4f1ef6607b971c009b0cd01c93eac3e87abd9626b0197b553fd4edba5f9c5.
//
// Solidity: event ContributorAccountUpdated(uint32 id, address oldAccount, address newAccount)
func (_Contributor *ContributorFilterer) WatchContributorAccountUpdated(opts *bind.WatchOpts, sink chan<- *ContributorContributorAccountUpdated) (event.Subscription, error) {

	logs, sub, err := _Contributor.contract.WatchLogs(opts, "ContributorAccountUpdated")
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(ContributorContributorAccountUpdated)
				if err := _Contributor.contract.UnpackLog(event, "ContributorAccountUpdated", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseContributorAccountUpdated is a log parse operation binding the contract event 0x3ac4f1ef6607b971c009b0cd01c93eac3e87abd9626b0197b553fd4edba5f9c5.
//
// Solidity: event ContributorAccountUpdated(uint32 id, address oldAccount, address newAccount)
func (_Contributor *ContributorFilterer) ParseContributorAccountUpdated(log types.Log) (*ContributorContributorAccountUpdated, error) {
	event := new(ContributorContributorAccountUpdated)
	if err := _Contributor.contract.UnpackLog(event, "ContributorAccountUpdated", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// ContributorContributorAddedIterator is returned from FilterContributorAdded and is used to iterate over the raw logs and unpacked data for ContributorAdded events raised by the Contributor contract.
type ContributorContributorAddedIterator struct {
	Event *ContributorContributorAdded // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *ContributorContributorAddedIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(ContributorContributorAdded)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(ContributorContributorAdded)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *ContributorContributorAddedIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *ContributorContributorAddedIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// ContributorContributorAdded represents a ContributorAdded event raised by the Contributor contract.
type ContributorContributorAdded struct {
	Id      uint32
	Account common.Address
	Raw     types.Log // Blockchain specific contextual infos
}

// FilterContributorAdded is a free log retrieval operation binding the contract event 0x72ad9d5c569f04611365a4b438e5136dfc467e00ca73b88f24034b45e0cb54bc.
//
// Solidity: event ContributorAdded(uint32 id, address account)
func (_Contributor *ContributorFilterer) FilterContributorAdded(opts *bind.FilterOpts) (*ContributorContributorAddedIterator, error) {

	logs, sub, err := _Contributor.contract.FilterLogs(opts, "ContributorAdded")
	if err != nil {
		return nil, err
	}
	return &ContributorContributorAddedIterator{contract: _Contributor.contract, event: "ContributorAdded", logs: logs, sub: sub}, nil
}

// WatchContributorAdded is a free log subscription operation binding the contract event 0x72ad9d5c569f04611365a4b438e5136dfc467e00ca73b88f24034b45e0cb54bc.
//
// Solidity: event ContributorAdded(uint32 id, address account)
func (_Contributor *ContributorFilterer) WatchContributorAdded(opts *bind.WatchOpts, sink chan<- *ContributorContributorAdded) (event.Subscription, error) {

	logs, sub, err := _Contributor.contract.WatchLogs(opts, "ContributorAdded")
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(ContributorContributorAdded)
				if err := _Contributor.contract.UnpackLog(event, "ContributorAdded", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseContributorAdded is a log parse operation binding the contract event 0x72ad9d5c569f04611365a4b438e5136dfc467e00ca73b88f24034b45e0cb54bc.
//
// Solidity: event ContributorAdded(uint32 id, address account)
func (_Contributor *ContributorFilterer) ParseContributorAdded(log types.Log) (*ContributorContributorAdded, error) {
	event := new(ContributorContributorAdded)
	if err := _Contributor.contract.UnpackLog(event, "ContributorAdded", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// ContributorContributorProfileUpdatedIterator is returned from FilterContributorProfileUpdated and is used to iterate over the raw logs and unpacked data for ContributorProfileUpdated events raised by the Contributor contract.
type ContributorContributorProfileUpdatedIterator struct {
	Event *ContributorContributorProfileUpdated // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *ContributorContributorProfileUpdatedIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(ContributorContributorProfileUpdated)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(ContributorContributorProfileUpdated)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *ContributorContributorProfileUpdatedIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *ContributorContributorProfileUpdatedIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// ContributorContributorProfileUpdated represents a ContributorProfileUpdated event raised by the Contributor contract.
type ContributorContributorProfileUpdated struct {
	Id            uint32
	OldHashDigest [32]byte
	NewHashDigest [32]byte
	Raw           types.Log // Blockchain specific contextual infos
}

// FilterContributorProfileUpdated is a free log retrieval operation binding the contract event 0xbf4649cac1c0dd79f552070f545de45adfbbde96ef8b717b6ee4e9b476f1b878.
//
// Solidity: event ContributorProfileUpdated(uint32 id, bytes32 oldHashDigest, bytes32 newHashDigest)
func (_Contributor *ContributorFilterer) FilterContributorProfileUpdated(opts *bind.FilterOpts) (*ContributorContributorProfileUpdatedIterator, error) {

	logs, sub, err := _Contributor.contract.FilterLogs(opts, "ContributorProfileUpdated")
	if err != nil {
		return nil, err
	}
	return &ContributorContributorProfileUpdatedIterator{contract: _Contributor.contract, event: "ContributorProfileUpdated", logs: logs, sub: sub}, nil
}

// WatchContributorProfileUpdated is a free log subscription operation binding the contract event 0xbf4649cac1c0dd79f552070f545de45adfbbde96ef8b717b6ee4e9b476f1b878.
//
// Solidity: event ContributorProfileUpdated(uint32 id, bytes32 oldHashDigest, bytes32 newHashDigest)
func (_Contributor *ContributorFilterer) WatchContributorProfileUpdated(opts *bind.WatchOpts, sink chan<- *ContributorContributorProfileUpdated) (event.Subscription, error) {

	logs, sub, err := _Contributor.contract.WatchLogs(opts, "ContributorProfileUpdated")
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(ContributorContributorProfileUpdated)
				if err := _Contributor.contract.UnpackLog(event, "ContributorProfileUpdated", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseContributorProfileUpdated is a log parse operation binding the contract event 0xbf4649cac1c0dd79f552070f545de45adfbbde96ef8b717b6ee4e9b476f1b878.
//
// Solidity: event ContributorProfileUpdated(uint32 id, bytes32 oldHashDigest, bytes32 newHashDigest)
func (_Contributor *ContributorFilterer) ParseContributorProfileUpdated(log types.Log) (*ContributorContributorProfileUpdated, error) {
	event := new(ContributorContributorProfileUpdated)
	if err := _Contributor.contract.UnpackLog(event, "ContributorProfileUpdated", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

